//+------------------------------------------------------------------+
//|                                                          Xox.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double StopLoss          = 20;          //SL  . 
extern double TakeProfit        = 30;          //TP  . 
extern double Lots              = 1;         // . - 
extern double Prots             = 0.1;         //  
extern double Kolihestvo_Barov  = 5;           //   
//-------------------------------------------------------------------
bool Work = true;    //  
//-------------------------------------------------------------------
int start()
   {
    int Total= OrdersTotal();     //   
    int Ticket;                   //  
   
    double 
    SL,        //SL  
    TP,        //TP  
    Min_Lot,   // - 
    Free,      //  
    One_Lot,   //  
    Steep,     //   
    Lts;       //   .       
    
    bool
    Opn_B   = false,    //   Bay
    Opn_S   = false;    //   Sell
//-------------------------------------------------------------------
   // 
   if(Bars < Kolihestvo_Barov)                                         // .   ..        
      {                                                                    
       Alert("   .   .");  //..  
       return;                                                    //..   
      }
   if(Work==false)                                                //                       
      {
       Alert(" .   .");         // 
       return;                                                    //  - 
      }
//-------------------------------------------------------------------
   // 
   int K= Kolihestvo_Barov;      //    
//-------------------------------------------------------------------
   double L_1= iCustom(NULL,0,"Go_go",K,0,0);  // 
   double L_2= iCustom(NULL,0,"Go_go",K,1,0);  //  
//-------------------------------------------------------------------
   if(Bid > L_2)     //   () .. 
      {
       Opn_B= true;  //..      Bae
      }
   if(Bid < L_1)     //   () ..
      {
       Opn_S= true;  //..     Sell
      }
//-------------------------------------------------------------------
   // 
   RefreshRates();                                       // 
   Min_Lot= MarketInfo(Symbol(),MODE_MINLOT);            // - 
   Free=    AccountFreeMargin();                         // 
   One_Lot= MarketInfo(Symbol(),MODE_MARGINREQUIRED);    //  
   Steep=   MarketInfo(Symbol(),MODE_LOTSTEP);           //  
   
   if(Lots > 0.01)            //     
      Lts= Lots;              //    
   else
      Lts= MathFloor(Free*Prots/One_Lot/Steep)*Steep; //    () 
      
   if(Lts < Min_Lot)                                  //    ..  
      Lts= Min_Lot;                                   //..  .   
      
   if(Lts*One_Lot > Free)                             // . .   . ..  
      {
       Alert("    ",Lts," ");    //..  ..
       return;                                        //..        
      }      
//----------------------------------------------------------------------------------------------
   // 
   while(true) 
      {
       if(Total==0 && Opn_B==true)              //   + 
         {                                      //..  Buy
          RefreshRates();                       // 
          SL= Bid - New_Stop(StopLoss)*Point;   // SL   
          TP= Bid + New_Stop(TakeProfit)*Point; // TP 
          Alert("  Bay,  ..");
          Ticket= OrderSend(Symbol(),OP_BUY,Lts,Ask,5,SL,TP);  // Buy
          if (Ticket > 0)                                      //
            {
             Alert("  Bay ",Ticket);
             return;
            }
          if (Fun_Error(GetLastError())==1)      //  
            continue;                            //  
          return;                                //   start()
         } 
       if(Total==0 && Opn_S==true)           //   +
         {                                   //..  Sell
          RefreshRates();                    // 
          SL= Ask + New_Stop(StopLoss)*Point;   // SL   
          TP= Ask - New_Stop(TakeProfit)*Point; // TP 
          Alert("  Sell,  ..");
          Ticket= OrderSend(Symbol(),OP_SELL,Lts,Bid,5,SL,TP);  // Buy
          if (Ticket > 0)                                      //
            {
             Alert("  Sell ",Ticket);
             return;
            }
          if (Fun_Error(GetLastError())==1)      //  
            continue;                            //  
          return;                                //   start()  
         } 
        break;                               //  while
      }  
//--------------------------------------------------------------------------------------------
    return;                                  //  
   }
//--------------------------------------------------------------------------------------------
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
//--------------------------------------------------------------------------------------------
int New_Stop(int Parametr)    //  
   {
    int Min_Dist= MarketInfo(Symbol(),MODE_STOPLEVEL);   // 
    if(Parametr < Min_Dist)                              //  ..
      {
       Parametr= Min_Dist;                               //.. . 
       Alert("   ");
      } 
    return(Parametr);                                    // 
   }    